<?php
/**
 * Clase Base DP para BaseCrCreditoCuotaDP
 *
 * @package    
 * @subpackage BaseCrCreditoCuotaDP
 * @author     Willy
 * @version    SVN:: BaseCrCreditoCuotaDP.class.php,v 1.1 2013-01-04 11:11:45 william.taype Exp $
 */
abstract class BaseCrCreditoCuotaDP extends CrCreditoCuotaBN
{
  /* Número de registros afectados */
  private $nRowsAffected;

  public function __construct($bSetDefault = true)
  {
    if( $bSetDefault instanceof CrCreditoCuotaBN )
    {
      $o_CrCreditoCuotaBN = $bSetDefault;
      if($o_CrCreditoCuotaBN->getIdcuota()) : $this->setIdcuota($o_CrCreditoCuotaBN->getIdcuota()); endif;
      if($o_CrCreditoCuotaBN->getFechacuota()) : $this->setFechacuota($o_CrCreditoCuotaBN->getFechacuota()); endif;
      if($o_CrCreditoCuotaBN->getMontototal()) : $this->setMontototal($o_CrCreditoCuotaBN->getMontototal()); endif;
      if($o_CrCreditoCuotaBN->getSaldototal()) : $this->setSaldototal($o_CrCreditoCuotaBN->getSaldototal()); endif;
      if($o_CrCreditoCuotaBN->getMontocapital()) : $this->setMontocapital($o_CrCreditoCuotaBN->getMontocapital()); endif;
      if($o_CrCreditoCuotaBN->getMontointeres()) : $this->setMontointeres($o_CrCreditoCuotaBN->getMontointeres()); endif;
      if($o_CrCreditoCuotaBN->getMontomora()) : $this->setMontomora($o_CrCreditoCuotaBN->getMontomora()); endif;
      if($o_CrCreditoCuotaBN->getEstado()) : $this->setEstado($o_CrCreditoCuotaBN->getEstado()); endif;
      if($o_CrCreditoCuotaBN->getMoneda()) : $this->setMoneda($o_CrCreditoCuotaBN->getMoneda()); endif;
      if($o_CrCreditoCuotaBN->getDiasmora()) : $this->setDiasmora($o_CrCreditoCuotaBN->getDiasmora()); endif;
      if($o_CrCreditoCuotaBN->getFechacreacion()) : $this->setFechacreacion($o_CrCreditoCuotaBN->getFechacreacion()); endif;
      if($o_CrCreditoCuotaBN->getUsuariocreacion()) : $this->setUsuariocreacion($o_CrCreditoCuotaBN->getUsuariocreacion()); endif;
      if($o_CrCreditoCuotaBN->getEliminado()) : $this->setEliminado($o_CrCreditoCuotaBN->getEliminado()); endif;
      if($o_CrCreditoCuotaBN->getFechaeliminado()) : $this->setFechaeliminado($o_CrCreditoCuotaBN->getFechaeliminado()); endif;
      if($o_CrCreditoCuotaBN->getUsuarioeliminado()) : $this->setUsuarioeliminado($o_CrCreditoCuotaBN->getUsuarioeliminado()); endif;
      if($o_CrCreditoCuotaBN->getIdcreditocrono()) : $this->setIdcreditocrono($o_CrCreditoCuotaBN->getIdcreditocrono()); endif;
    }
  }

  /* Obtiene el número de registros afectados */
  public function getRowsAffected()
  {
    return $this->nRowsAffected;
  }

  public function save()
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT IF(MAX(idcuota),(MAX(idcuota)+1), 1) AS Maximo FROM cr_credito_cuota;";
      $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
      $result = mysql_query($sql, $oLink);
      $row = mysql_fetch_array($result);
      $this->setIdcuota($row[0]);

      if($this->getIdcuota()){
        $a_Fields = array();

        if($this->getIdcuota()) : $a_Fields['idcuota'] = ($this->getIdcuota()); endif;
        if($this->getFechacuota()) : $a_Fields['fechacuota'] = ($this->getFechacuota()); endif;
        if($this->getMontototal()) : $a_Fields['montototal'] = ($this->getMontototal()); endif;
        if($this->getSaldototal()) : $a_Fields['saldototal'] = ($this->getSaldototal()); endif;
        if($this->getMontocapital()) : $a_Fields['montocapital'] = ($this->getMontocapital()); endif;
        if($this->getMontointeres()) : $a_Fields['montointeres'] = ($this->getMontointeres()); endif;
        if($this->getMontomora()) : $a_Fields['montomora'] = ($this->getMontomora()); endif;
        if($this->getEstado()) : $a_Fields['estado'] = ($this->getEstado()); endif;
        if($this->getMoneda()) : $a_Fields['moneda'] = ($this->getMoneda()); endif;
        if($this->getDiasmora()) : $a_Fields['diasmora'] = ($this->getDiasmora()); endif;
        if($this->getFechacreacion()) : $a_Fields['fechacreacion'] = ($this->getFechacreacion()); endif;
        if($this->getUsuariocreacion()) : $a_Fields['usuariocreacion'] = ($this->getUsuariocreacion()); endif;
        if($this->getEliminado()) : $a_Fields['eliminado'] = ($this->getEliminado()); endif;
        if($this->getFechaeliminado()) : $a_Fields['fechaeliminado'] = ($this->getFechaeliminado()); endif;
        if($this->getUsuarioeliminado()) : $a_Fields['usuarioeliminado'] = ($this->getUsuarioeliminado()); endif;
        if($this->getIdcreditocrono()) : $a_Fields['idcreditocrono'] = ($this->getIdcreditocrono()); endif;

        $sStringField = arrayClass::implode_keys(',', $a_Fields);
        $sStringValue = "'".implode("','", $a_Fields)."'";

        $sql = "INSERT INTO cr_credito_cuota (".$sStringField.") VALUES (".$sStringValue.");";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  public function update()
  {
    try
    {
      if($this->getIdcuota())
      {
        $a_Fields = array();

        if($this->getIdcuota()) : $a_Fields['idcuota'] = ($this->getIdcuota()); endif;
        if($this->getFechacuota()) : $a_Fields['fechacuota'] = ($this->getFechacuota()); endif;
        if($this->getMontototal()) : $a_Fields['montototal'] = ($this->getMontototal()); endif;
        if($this->getSaldototal()) : $a_Fields['saldototal'] = ($this->getSaldototal()); endif;
        if($this->getMontocapital()) : $a_Fields['montocapital'] = ($this->getMontocapital()); endif;
        if($this->getMontointeres()) : $a_Fields['montointeres'] = ($this->getMontointeres()); endif;
        if($this->getMontomora()) : $a_Fields['montomora'] = ($this->getMontomora()); endif;
        if($this->getEstado()) : $a_Fields['estado'] = ($this->getEstado()); endif;
        if($this->getMoneda()) : $a_Fields['moneda'] = ($this->getMoneda()); endif;
        if($this->getDiasmora()) : $a_Fields['diasmora'] = ($this->getDiasmora()); endif;
        if($this->getFechacreacion()) : $a_Fields['fechacreacion'] = ($this->getFechacreacion()); endif;
        if($this->getUsuariocreacion()) : $a_Fields['usuariocreacion'] = ($this->getUsuariocreacion()); endif;
        if($this->getEliminado()) : $a_Fields['eliminado'] = ($this->getEliminado()); endif;
        if($this->getFechaeliminado()) : $a_Fields['fechaeliminado'] = ($this->getFechaeliminado()); endif;
        if($this->getUsuarioeliminado()) : $a_Fields['usuarioeliminado'] = ($this->getUsuarioeliminado()); endif;
        if($this->getIdcreditocrono()) : $a_Fields['idcreditocrono'] = ($this->getIdcreditocrono()); endif;

        $sStringField = arrayClass::implode_key_value(',', $a_Fields);

        $con = Conexion::getConexion();
        $sql = "UPDATE cr_credito_cuota SET ".$sStringField." WHERE 1 AND idcuota='".$this->getIdcuota()."';";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  public function delete()
  {
    try
    {
      if($this->getIdcuota())
      {
        $a_Fields = array();

        $con = Conexion::getConexion();
        $sql = "DELETE FROM cr_credito_cuota WHERE 1 AND idcuota='".$this->getIdcuota()."';"; 
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  /* Búsqueda del registro por la llave primaria */
  public static function selectByPK($vIdcuota)
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT idcuota, fechacuota, montototal, saldototal, montocapital, montointeres, montomora, estado, moneda, diasmora, fechacreacion, usuariocreacion, eliminado, fechaeliminado, usuarioeliminado, idcreditocrono FROM cr_credito_cuota WHERE 1 AND idcuota='".$vIdcuota."'; ";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      
      return $o_Propel?self::insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con métodos de acceso */
  private function insertObjectBN($o_propel){
    $o_CrCreditoCuotaDP = new CrCreditoCuotaDP();
    $o_CrCreditoCuotaDP->setIdcuota($o_propel->idcuota);
    $o_CrCreditoCuotaDP->setFechacuota($o_propel->fechacuota);
    $o_CrCreditoCuotaDP->setMontototal($o_propel->montototal);
    $o_CrCreditoCuotaDP->setSaldototal($o_propel->saldototal);
    $o_CrCreditoCuotaDP->setMontocapital($o_propel->montocapital);
    $o_CrCreditoCuotaDP->setMontointeres($o_propel->montointeres);
    $o_CrCreditoCuotaDP->setMontomora($o_propel->montomora);
    $o_CrCreditoCuotaDP->setEstado($o_propel->estado);
    $o_CrCreditoCuotaDP->setMoneda($o_propel->moneda);
    $o_CrCreditoCuotaDP->setDiasmora($o_propel->diasmora);
    $o_CrCreditoCuotaDP->setFechacreacion($o_propel->fechacreacion);
    $o_CrCreditoCuotaDP->setUsuariocreacion($o_propel->usuariocreacion);
    $o_CrCreditoCuotaDP->setEliminado($o_propel->eliminado);
    $o_CrCreditoCuotaDP->setFechaeliminado($o_propel->fechaeliminado);
    $o_CrCreditoCuotaDP->setUsuarioeliminado($o_propel->usuarioeliminado);
    $o_CrCreditoCuotaDP->setIdcreditocrono($o_propel->idcreditocrono);
    return $o_CrCreditoCuotaDP;
  }
}